//+------------------------------------------------------------------+
//|                                                      8TF HAS.mq4 |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_minimum 1
#property indicator_maximum 9
#property indicator_buffers 8
#property indicator_color1 Blue
#property indicator_color2 Blue
#property indicator_color3 Blue
#property indicator_color4 Blue
#property indicator_color5 Blue
#property indicator_color6 Blue
#property indicator_color7 Blue
#property indicator_color8 Blue
#property indicator_level1 1.7
#property indicator_level2 2.7
#property indicator_level3 3.7
#property indicator_level4 4.7
#property indicator_level5 5.7
#property indicator_level6 6.7
#property indicator_level7 7.7
#property indicator_levelcolor Blue
#property indicator_levelstyle 0

//---- parameters
extern int MaMetod  = 2;
extern int MaPeriod = 6;
extern int MaMetod2  = 3;
extern int MaPeriod2 = 2;

//---- buffers
double buf8[];
double buf7[];
double buf6[];
double buf5[];
double buf4[];
double buf3[];
double buf2[];
double buf1[];
double haOpen;
double haClose;

double Gap = 1; // Gap between the lines of bars
string shortname = "";
bool firstTime = true;

int ArrSize = 110;//159;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
 
   firstTime = true;
   
   //IndicatorShortName(shortname);
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,ArrSize);
   SetIndexBuffer(0,buf8);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,ArrSize);
   SetIndexBuffer(1,buf7);
   SetIndexEmptyValue(1,0.0);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,ArrSize);
   SetIndexBuffer(2,buf6);
   SetIndexEmptyValue(2,0.0);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,ArrSize);
   SetIndexBuffer(3,buf5);
   SetIndexEmptyValue(3,0.0);
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4,ArrSize);
   SetIndexBuffer(4,buf4);
   SetIndexEmptyValue(4,0.0);
   SetIndexStyle(5,DRAW_ARROW);
   SetIndexArrow(5,ArrSize);
   SetIndexBuffer(5,buf3);
   SetIndexEmptyValue(5,0.0);
   SetIndexStyle(6,DRAW_ARROW);
   SetIndexArrow(6,ArrSize);
   SetIndexBuffer(6,buf2);
   SetIndexEmptyValue(6,0.0);
   SetIndexStyle(7,DRAW_ARROW);
   SetIndexArrow(7,ArrSize);
   SetIndexBuffer(7,buf1);
   SetIndexEmptyValue(7,0.0);
   
   IndicatorDigits(0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   firstTime = true;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   int i=0, y1=0, y2=0, y3=0, y4=0, y5=0, y6=0, y7=0, y8=0, yy;
   int limit=Bars-counted_bars;
   
   int Period_1, Period_2, Period_3, Period_4, Period_5, Period_6, Period_7, Period_8;
   switch(Period()) 
      {
         case 1: 
            Period_1=1; Period_2=5; Period_3=15; Period_4=30; Period_5=60; Period_6=240; Period_7=1440; Period_8=10080;
            break;
         case 5: 
            Period_1=5; Period_2=15; Period_3=30; Period_4=60; Period_5=240; Period_6=1440; Period_7=10080; Period_8=43200;
            break;
         case 15: 
            Period_1=15; Period_2=30; Period_3=60; Period_4=240; Period_5=1440; Period_6=10080; Period_7=43200; Period_8=43200;
            break;
         case 30: 
            Period_1=30; Period_2=60; Period_3=240; Period_4=1440; Period_5=10080; Period_6=43200; Period_7=43200; Period_8=43200;
            break;
         case 60: 
            Period_1=60; Period_2=240; Period_3=1440; Period_4=10080; Period_5=43200; Period_6=43200; Period_7=43200; Period_8=43200;
            break;
         case 240: 
            Period_1=240; Period_2=1440; Period_3=10080; Period_4=43200; Period_5=43200; Period_6=43200; Period_7=43200; Period_8=43200;
            break;
         case 1440: 
            Period_1=1440; Period_2=10080; Period_3=43200; Period_4=43200; Period_5=43200; Period_6=43200; Period_7=43200; Period_8=43200;
            break;
         case 10080: 
            Period_1=10080; Period_2=43200; Period_3=43200; Period_4=43200; Period_5=43200; Period_6=43200; Period_7=43200; Period_8=43200;
            break;
         case 43200: 
            Period_1=43200; Period_2=43200; Period_3=43200; Period_4=43200; Period_5=43200; Period_6=43200; Period_7=43200; Period_8=43200;
            break;
         
      }
        
      
   shortname = "MTF HAS ("+Period_1+","+Period_2+","+Period_3+","+Period_4+","+Period_5+","+Period_6+","+Period_7+","+Period_8+")";
   IndicatorShortName(shortname);

   datetime TimeArray1[], TimeArray2[], TimeArray3[], TimeArray4[], TimeArray5[], TimeArray6[], TimeArray7[], TimeArray8[];
//----

   
   
   if (firstTime || NewBar())
   {
      firstTime = false;
      int win = ArrSize; // WindowFind(shortname);
      double dif = Time[0] - Time[1];
      for (int ii=ObjectsTotal()-1; ii>-1; ii--)
      {
         if (StringFind(ObjectName(ii),"HAS_"+win) >= 0)
            ObjectDelete(ObjectName(ii));
         else 
            ii=-1;
      }
      
      double shift = 0.2;
      for (ii=0; ii<8; ii++)
      {  
         string txt = "??";
         double gp;
         switch (ii)
         {
            case 0: txt = tf2txt(Period_1);  gp = 1 + shift; break;
            case 1: txt = tf2txt(Period_2);  gp = 1 + Gap + shift; break;
            case 2: txt = tf2txt(Period_3);  gp = 1 + Gap*2 + shift; break;
            case 3: txt = tf2txt(Period_4);  gp = 1 + Gap*3 + shift; break;
            case 4: txt = tf2txt(Period_5);  gp = 1 + Gap*4 + shift; break;
            case 5: txt = tf2txt(Period_6);  gp = 1 + Gap*5 + shift; break;
            case 6: txt = tf2txt(Period_7);  gp = 1 + Gap*6 + shift; break;
            case 7: txt = tf2txt(Period_8);  gp = 1 + Gap*7 + shift; break;
         }
         
         string name = "HAS_"+win+"_"+ii;
         ObjectCreate(name, OBJ_TEXT, WindowFind(shortname), iTime(NULL,0,0)+dif*3, gp+0.4);
         ObjectSetText(name, txt,8,"Arial", Black);
      }
   }
   
   ArrayCopySeries(TimeArray8,MODE_TIME,Symbol(),Period_8); 
   ArrayCopySeries(TimeArray7,MODE_TIME,Symbol(),Period_7); 
   ArrayCopySeries(TimeArray6,MODE_TIME,Symbol(),Period_6); 
   ArrayCopySeries(TimeArray5,MODE_TIME,Symbol(),Period_5); 
   ArrayCopySeries(TimeArray4,MODE_TIME,Symbol(),Period_4); 
   ArrayCopySeries(TimeArray3,MODE_TIME,Symbol(),Period_3); 
   ArrayCopySeries(TimeArray2,MODE_TIME,Symbol(),Period_2);
   ArrayCopySeries(TimeArray1,MODE_TIME,Symbol(),Period_1); 
      
   for(i=0,y1=0,y2=0,y3=0,y4=0,y5=0,y6=0,y7=0,y8=0;i<limit;i++)
   {
      if (Time[i]<TimeArray1[y1]) y1++;
      if (Time[i]<TimeArray2[y2]) y2++;
      if (Time[i]<TimeArray3[y3]) y3++;
      if (Time[i]<TimeArray4[y4]) y4++;
      if (Time[i]<TimeArray5[y5]) y5++;
      if (Time[i]<TimeArray6[y6]) y6++;
      if (Time[i]<TimeArray7[y7]) y7++;
      if (Time[i]<TimeArray8[y8]) y8++;


      for (int tf = 0; tf < 8; tf++)
      {
         int prd;
         switch (tf)
         {
            case 0: prd = Period_1; 
                    yy = y1;  
                    break;
            case 1: prd = Period_2; 
                    yy = y2;  
                    break;
            case 2: prd = Period_3;  
                    yy = y3;   
                    break;
            case 3: prd = Period_4;  
                    yy = y4;   
                    break;
            case 4: prd = Period_5;  
                    yy = y5;   
                    break;
            case 5: prd = Period_6;  
                    yy = y6;   
                    break;
            case 6: prd = Period_7;  
                    yy = y7;   
                    break;
            case 7: prd = Period_8;  
                    yy = y8;   
                    break;
         }
         
        
         haOpen = iCustom(NULL,prd,"Heiken_Ashi_Smoothed",MaMetod,MaPeriod,MaMetod2,MaPeriod2,2,yy) ;
         haClose = iCustom(NULL,prd,"Heiken_Ashi_Smoothed",MaMetod,MaPeriod,MaMetod2,MaPeriod2,3,yy) ;
         
         double dUp = EMPTY_VALUE;
         double dDn = EMPTY_VALUE;
         
         if (haOpen<haClose) dUp = 1; else dDn = 1;
         
         switch (tf)
         {
            case 0: if (dUp == 1)  buf1[i] = 1;           
                    else buf1[i] = EMPTY_VALUE; break;
            case 1: if (dUp == 1)  buf2[i] = 1 + Gap * 1; 
                    else buf2[i] = EMPTY_VALUE; break;
            case 2: if (dUp == 1)  buf3[i]  = 1 + Gap * 2; 
                    else buf3[i] = EMPTY_VALUE; break;
            case 3: if (dUp == 1)  buf4[i]  = 1  + Gap * 3; 
                    else buf4[i]  = EMPTY_VALUE; break;
            case 4: if (dUp == 1)  buf5[i]  = 1  + Gap * 4; 
                    else buf5[i]  = EMPTY_VALUE; break;
            case 5: if (dUp == 1)  buf6[i]  = 1  + Gap * 5; 
                    else buf6[i]  = EMPTY_VALUE; break;
            case 6: if (dUp == 1)  buf7[i]  = 1  + Gap * 6; 
                    else buf7[i]  = EMPTY_VALUE; break;
            case 7: if (dUp == 1)  buf8[i]  = 1  + Gap * 7; 
                    else buf8[i]  = EMPTY_VALUE; break;
         }
      }
   }

   return(0);
  }
//+------------------------------------------------------------------+

string tf2txt(int tf)
{
   if (tf == PERIOD_M1)    return("M1");
   if (tf == PERIOD_M5)    return("M5");
   if (tf == PERIOD_M15)    return("M15");
   if (tf == PERIOD_M30)    return("M30");
   if (tf == PERIOD_H1)    return("H1");
   if (tf == PERIOD_H4)    return("H4");
   if (tf == PERIOD_D1)    return("D1");
   if (tf == PERIOD_W1)    return("W1");
   if (tf == PERIOD_MN1)    return("MN1");
   
   return("??");
}


bool NewBar()
{
   static datetime dt = 0;
   
   if (Time[0] != dt)
   {
      dt = Time[0];
      return(true);
   }
   return(false);
}




